#ifndef KEYPAD_H_
#define KEYPAD_H_
	/******************************************************************************
	
    KEYPAD

    ******************************************************************************/

#include <avr/io.h>
#include <util/delay.h>
#include "lcd.h"
    

#define KEYPAD D  //KEYPAD IS ATTACHED ON PORTB


    //Don't touch the lines below
    //*******************************
#define KEYPAD_PORT PORTA
#define KEYPAD_DDR   DDRA
#define KEYPAD_PIN   PINA
	//*******************************


    /*******************************************
	
	Function return the keycode of keypressed
	on the Keypad. Keys are numbered as follows
	
	[00] [01] [02] [03] 
	[04] [05] [06] [07] 
	[08] [09] [10] [11]
	[12] [13] [14] [15]
	[16] [17] [18] [19]
	
	Arguments:
		None
	
	Return:
		Any number between 0-19 depending on
		keypressed.
	
		255 (hex 0xFF) if NO keypressed.
	
   Precondition:
      None. Can be called without any setup.

  *******************************************/

#define	NUMROW	5 
#define NUMCOL	4 

// key defines
 
#define KEY_UP 'u' 
#define KEY_DOWN 'd' 
#define KEY_LEFT 'l' 
#define KEY_RIGHT 'r' 
#define KEY_F1 'o' 
#define KEY_F2 'h' 
#define KEY_DIEZ '#' 
#define KEY_STAR '*' 
#define KEY_ESC 'e' 
#define KEY_ENTER '/' 
#define KEY_NULL (char)0xFF

class Keypad {
private:
	uint8_t pos_key, inc, nrs, canReturnVar;
	uint32_t code;

	// Gaseste tasta apasata
public:
	Keypad() { 	}
	
	char GetKeyPressed();

	void resetAll();
	
	
	// Transforma codul tastei in caractere
	char decodeKey(uint8_t key);


	uint8_t canReturn();
	// Afiseaza pe LCD tasta apasata
	void displayKey(char key);
	
	void readCode();

	uint32_t getCode();
	#endif // KEYPAD_H_
};